using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;

namespace MapTest
{
    public partial class FormMoreCar : Form
    {
        public FormMoreCar(ref Label _lblData, ref Socket soc, ref eUp_UCMap.UCMap _ucMap)
        {
            InitializeComponent();
            this.lblGPSData = _lblData;
            this.lblGPSData.TextChanged += new EventHandler(DisplayMoreCar);
            this.m_clientSocket = soc;
            this.ucMap = _ucMap;
            for (int i = 0; i < 6; i++)
            {
                this.clsMapData[i] = new CarMapData();
                this.clsMapData[i].strUnicode = i.ToString();
            }
        }
        // ܦhlܹϸ
        private void DisplayMoreCar(object sender, EventArgs e)
        {
            this.SetShowMoreCar(this.lblGPSData.Text);
        }
        // ܦhlܹϸBzee
        private void SetShowMoreCar(string strData)
        {
          //if I remove follows  code, it will throw exception: Cross-thread operation not valid: Control 'WinformsMap1' accessed from a thread other than the thread it was created on.
            
            //if (this.InvokeRequired)
            //{
            //    this.BeginInvoke(new dlgShowMoreCar(SetShowMoreCar), new object[] { strData });
            //    return;
            //}

            this.ShowMoreCar(strData);
        }
        // ܸƳBz
        private void ShowMoreCar(string strData)
        {
            int intFGPSX, intFGPSY;
            try
            {
                if (strData != null && strData != "")
                {
                    if (strData.IndexOf("NULL") < 0)
                    {
                        string[] strGPSData = strData.Trim().Split(',');

                        int lgLat = Convert.ToInt32(strGPSData[2]);
                        int lgLot = Convert.ToInt32(strGPSData[1]);
                        double[] dbFix = this.ucMap.FixGPSPosition(lgLot / 1000000, lgLat / 1000000);
                        intFGPSX = Convert.ToInt32(dbFix[0]);
                        intFGPSY = Convert.ToInt32(dbFix[1]);
                        if (intFGPSX == 0)
                        {
                            this.SetCarMap(strGPSData[0], lgLot, lgLat);
                        }
                        else
                        {
                            this.SetCarMap(strGPSData[0], intFGPSX, intFGPSY);
                        }
                    }
                    else
                    {
                        MessageBox.Show("No Data!", "System Information");
                    }
                }
            }
            catch (Exception ex)
            {
                (this.MdiParent as Form1).RecErrMessage(ex.Message, "ShowMoreCar:" + strData, this.lblGPSData.Text);
            }
        }
        private void SetCarMap(string strUnicode, int intGISX, int intGISY)
        {
            if (this.InvokeRequired)
            {
                this.BeginInvoke(new SetCarMapData(SetCarMap), new object[] { strUnicode, intGISX, intGISY });
                return;
            }

            this.ucMap.SetMapCenterXY(Convert.ToDouble(intGISX) / 1000000, Convert.ToDouble(intGISY) / 1000000);
            this.ucMap.SetMapCurrentScale(9);
            for (int i = 0; i < 6; i++)
            {
                if (this.clsMapData[i].strUnicode == strUnicode)
                {
                    this.clsMapData[i].intGISX = intGISX;
                    this.clsMapData[i].intGISY = intGISY;
                    this.ucMap.SetMapCurrentScale(10);
                    switch (strUnicode)
                    {
                        case "0":
                            this.ucMap.SetImageSize(this.pbMap1.Width, this.pbMap1.Height);
                            this.pbMap1.Image = (Image)this.ucMap.GetMapBitmap(this.pbMap1.Width, this.pbMap1.Height);
                            //this.pbMap1.Image = (Image)this.ucMap.GetMapBitmap(260, 299);
                            //this.pictureBox1.Image = (Image)this.ucMap.GetMapBitmap(this.pictureBox1.Width, this.pictureBox1.Height);
                            break;

                        case "1":
                            this.ucMap.SetImageSize(this.pbMap2.Width, this.pbMap2.Height);
                            this.pbMap2.Image = (Image)this.ucMap.GetMapBitmap(this.pbMap2.Width, this.pbMap2.Height);
                            //this.pbMap2.Image = (Image)this.ucMap.GetMapBitmap(260, 299);
                            //this.pictureBox2.Image = (Image)this.ucMap.GetMapBitmap(this.pictureBox2.Width, this.pictureBox2.Height);
                            break;

                        case "2":
                            this.ucMap.SetImageSize(this.pbMap3.Width, this.pbMap3.Height);
                            this.pbMap3.Image = (Image)this.ucMap.GetMapBitmap(this.pbMap3.Width, this.pbMap3.Height);
                            //this.pbMap3.Image = (Image)this.ucMap.GetMapBitmap(260, 299);
                            //this.pictureBox3.Image = (Image)this.ucMap.GetMapBitmap(this.pictureBox3.Width, this.pictureBox3.Height);
                            break;

                        case "3":
                            this.ucMap.SetImageSize(this.pbMap4.Width, this.pbMap4.Height);
                            this.pbMap4.Image = (Image)this.ucMap.GetMapBitmap(this.pbMap4.Width, this.pbMap4.Height);
                            //this.pbMap4.Image = (Image)this.ucMap.GetMapBitmap(260, 299);
                            //this.pictureBox4.Image = (Image)this.ucMap.GetMapBitmap(this.pictureBox4.Width, this.pictureBox4.Height);
                            break;

                        case "4":
                            this.ucMap.SetImageSize(this.pbMap5.Width, this.pbMap5.Height);
                            this.pbMap5.Image = (Image)this.ucMap.GetMapBitmap(this.pbMap5.Width, this.pbMap5.Height);
                            //this.pbMap5.Image = (Image)this.ucMap.GetMapBitmap(260, 299);
                            //this.pictureBox5.Image = (Image)this.ucMap.GetMapBitmap(this.pictureBox5.Width, this.pictureBox5.Height);
                            break;

                        case "5":
                            this.ucMap.SetImageSize(this.pbMap6.Width, this.pbMap6.Height);
                            this.pbMap6.Image = (Image)this.ucMap.GetMapBitmap(this.pbMap6.Width, this.pbMap6.Height);
                            //this.pbMap6.Image = (Image)this.ucMap.GetMapBitmap(260, 299);
                            //this.pictureBox6.Image = (Image)this.ucMap.GetMapBitmap(this.pictureBox6.Width, this.pictureBox6.Height);
                            break;
                    }
                }
            }
        }

        private Socket m_clientSocket;
        private Label lblGPSData;
        private eUp_UCMap.UCMap ucMap;
        private char charCR = (char)13;
        private int intIndex = 0;
        private CarMapData[] clsMapData = new CarMapData[6];
        private delegate void dlgShowMoreCar(string strData);
        private delegate void SetCarMapData(string strUnicode, int intGISX, int intGISY);
        private class CarMapData
        {
            public string strUnicode = "";
            public int intGISX = 0;
            public int intGISY = 0;
        }

        private void FormMoreCar_Load(object sender, EventArgs e)
        {
            this.timer1.Interval = 100;
            this.timer1.Enabled = true;
        }

        private void btnGetMap_Click(object sender, EventArgs e)
        {
            if (m_clientSocket != null && m_clientSocket.Connected)
            {
                for (int i = 1; i < 7; i++)
                {
                    m_clientSocket.Send(System.Text.Encoding.Unicode.GetBytes("A" + i.ToString() + "?" + this.charCR));
                }
            }
            else
            {
                MessageBox.Show("m_clientSocket Fail");
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (m_clientSocket != null && m_clientSocket.Connected)
            {
                intIndex++;
                m_clientSocket.Send(System.Text.Encoding.Unicode.GetBytes("A" + intIndex.ToString() + "?" + this.charCR));
                if (intIndex >= 7) this.timer1.Enabled = false;//intIndex = 0;// 
            }
        }
    }
}